#!/bin/sh
#
# Configuration lt. Anleitung von https://www.gehrig.info/alexa/Alexa.html ##

CCU='1'									# auf 1 setzten, wenn das Script auf einer CCU läuft

HOST='layla.amazon.de'
#HOST='pitangui.amazon.com'

DEVICENUMBER="xxx"
DEVICETYPE="xxx"
CSRF="csrf: xxx" 
COOKIE="xxx"
CUSTOMERID="xxx"



tunein_default="s83744"											# default radiostation for tunein
prime_radio_default="AWQEQ4SVHXTEX"								# default radiostation for primemusic
prime_playlist_default="B01N3UD4N6"								# default playlist for primemusic
cloud_track_default="63c99e9a-87fc-4e68-ac0d-a9b9b2c0ba1a"		# default track from cloud
cloud_playlist_default="7daba127-2c98-431f-a4bf-b1155cfcd0d1"	# default playlist from cloud


# Senderliste/Playlisten #
oe3="tunein:s83744"
liferadio="tunein:s149494"
antennetirol="tunein:s149502"
Country="prime_radio:AWQEQ4SVHXTEX"
Rock80er="prime_playlist:B01N3UD4N6"
Putzibaer="cloud_track:63c99e9a-87fc-4e68-ac0d-a9b9b2c0ba1a"
meine_playlist="cloud_playlist:7daba127-2c98-431f-a4bf-b1155cfcd0d1"

# Ende Config ##############################################################


# ab hier sollten keine Änderungen mehr nötig sein

send_command(){
	URL='https://'$HOST'/api/np/command?deviceSerialNumber='$DEVICENUMBER'&deviceType='$DEVICETYPE
	if [ $CCU = "1" ] ; then
		/usr/local/addons/cuxd/extra/curl --compressed -s -k $URL -H "$COOKIE" -H "$CSRF" --data "${CMD}"
	else
		curl --compressed -s -k $URL -H "$COOKIE" -H "$CSRF" --data "${CMD}"
	fi
}
send_command2(){		# TuneIn
	URL2='https://'$HOST'/api/tunein/queue-and-play?deviceSerialNumber='$DEVICENUMBER'&deviceType='$DEVICETYPE'&guideId='$STATION'&contentType=station&callSign=&mediaOwnerCustomerId='$CUSTOMERID 
	if [ $CCU = "1" ] ; then
		/usr/local/addons/cuxd/extra/curl --compressed -s -k $URL2 -X POST -H "Accept-Encoding: gzip, deflate, br" -H "Content-Type: application/json; charset=UTF-8" -H "Accept: application/json, text/javascript, */*; q=0.01" -H "$CSRF" -H "$COOKIE" -H "Connection: keep-alive" -H "Content-Length: 0" -H "DNT: 1"
	else
		curl --compressed -s -k $URL2 -X POST -H "Accept-Encoding: gzip, deflate, br" -H "Content-Type: application/json; charset=UTF-8" -H "Accept: application/json, text/javascript, */*; q=0.01" -H "$CSRF" -H "$COOKIE" -H "Connection: keep-alive" -H "Content-Length: 0" -H "DNT: 1"
	fi
}
send_command3(){		# PrimeMusic Radiosender
	CMD='{"seed":"{\"type\":\"KEY\",\"seedId\":\"'$SEEDID'\"}","stationName":"station","seedType":"KEY"}'
	URL3='https://'$HOST'/api/gotham/queue-and-play?deviceSerialNumber='$DEVICENUMBER'&deviceType='$DEVICETYPE'&mediaOwnerCustomerId='$CUSTOMERID 
	if [ $CCU = "1" ] ; then
		/usr/local/addons/cuxd/extra/curl --compressed -s -k $URL3 -H "Accept-Encoding: gzip, deflate, br" -H "Content-Type: application/json; charset=UTF-8" -H "Accept: application/json, text/javascript, */*; q=0.01" -H "$CSRF" -H "$COOKIE" -H "Connection: keep-alive" --data-binary "${CMD}" 
	else
		curl --compressed -s -k $URL3 -H "Accept-Encoding: gzip, deflate, br" -H "Content-Type: application/json; charset=UTF-8" -H "Accept: application/json, text/javascript, */*; q=0.01" -H "$CSRF" -H "$COOKIE" -H "Connection: keep-alive" --data-binary "${CMD}" 
	fi
}
send_command4(){		# PrimeMusic Playlisten
	CMD='{"asin":"'$ASIN'"}'
	URL4='https://'$HOST'/api/prime/prime-playlist-queue-and-play?deviceSerialNumber='$DEVICENUMBER'&deviceType='$DEVICETYPE'&mediaOwnerCustomerId='$CUSTOMERID
	if [ $CCU = "1" ] ; then
		/usr/local/addons/cuxd/extra/curl --compressed -s -k $URL4 -H 'Accept-Encoding: gzip, deflate, br' -H 'Content-Type: application/json; charset=UTF-8' -H 'Accept: application/json, text/javascript, */*; q=0.01' -H "$CSRF" -H "$COOKIE" -H 'Connection: keep-alive' --data-binary "${CMD}"
	else
		curl --compressed -s -k $URL4 -H 'Accept-Encoding: gzip, deflate, br' -H 'Content-Type: application/json; charset=UTF-8' -H 'Accept: application/json, text/javascript, */*; q=0.01' -H "$CSRF" -H "$COOKIE" -H 'Connection: keep-alive' --data-binary "${CMD}"
	fi
}
send_command5(){
	URL5='https://'$HOST'/api/cloudplayer/queue-and-play?deviceSerialNumber='$DEVICENUMBER'&deviceType='$DEVICETYPE'&shuffle=false&mediaOwnerCustomerId='$CUSTOMERID
	if [ $CCU = "1" ] ; then
		/usr/local/addons/cuxd/extra/curl --compressed -s -k $URL5 -H 'Accept-Encoding: gzip, deflate, br' -H 'Content-Type: application/json; charset=UTF-8' -H 'Accept: application/json, text/javascript, */*; q=0.01' -H "$CSRF" -H "$COOKIE" -H 'Connection: keep-alive' --data-binary "${CMD}"
	else
		curl --compressed -s -k $URL5 -H 'Accept-Encoding: gzip, deflate, br' -H 'Content-Type: application/json; charset=UTF-8' -H 'Accept: application/json, text/javascript, */*; q=0.01' -H "$CSRF" -H "$COOKIE" -H 'Connection: keep-alive' --data-binary "${CMD}"
	fi
}


case $1 in
	"test") 
		echo "for development only"
	;;

	"play") 
		INPUT=$(eval echo \$$2)
		if [ -z "$INPUT" ]; then
			echo "use ./alexa.sh play stationname  # resume is used if empty/on mismatch"
			CMD='{"type":"PlayCommand"}'
			send_command
		else 
			stream=`echo  "$INPUT" | awk -F':' '{print $1}'`
			if [ $stream = "tunein" ] ; then 
				STATION=`echo  "$INPUT" | awk -F':' '{print $2}'`
				send_command2
			elif [ $stream = "prime_radio" ] ; then 
				SEEDID=`echo  "$INPUT" | awk -F':' '{print $2}'`
				send_command3
			elif [ $stream = "prime_playlist" ] ; then 
				ASIN=`echo  "$INPUT" | awk -F':' '{print $2}'`
				send_command4
			elif [ $stream = "cloud_track" ] ; then 
				TRACKID=`echo  "$INPUT" | awk -F':' '{print $2}'`
				CMD='{"trackId":"'$TRACKID'", "playQueuePrime":true}'
				send_command5
			elif [ $stream = "cloud_playlist" ] ; then 
				PLAYLISTID=`echo  "$INPUT" | awk -F':' '{print $2}'`
				CMD='{"playlistId":"'$PLAYLISTID'","playQueuePrime":false}'
				send_command5
				
			else
				echo "$stream nicht erkannt"
			fi
		fi 	
	;;
	
	"resume")  	
		CMD='{"type":"PlayCommand"}'
		send_command
	;;
	"pause")  	
		CMD='{"type":"PauseCommand"}'
		send_command
	;;
	
	"next")  		
		CMD='{"type":"NextCommand"}'
		send_command
	;;
	"prev")  		
		CMD='{"type":"PreviousCommand"}'
		send_command
	;;
	
	"vol")
		INPUT=$2
			if [ -z "$INPUT" ]; then
			echo "use ./alexa.sh vol 40  # Use something between 0-100, 40 is set if empty"
			INPUT='40'
		fi
		CMD='{"type":"VolumeLevelCommand","volumeLevel":'$INPUT'}'
		send_command
	;;
	
	"shuffle")
		INPUT=$2
		if [ -z "$INPUT" ]; then
			echo "use ./alexa.sh shuffle on  # use on/off, off is set if empty or on mismatch"
			INPUT='off'
		fi
		if [ $INPUT = "on" ] ; then
			CMD='{"type":"ShuffleCommand","shuffle":true}'
		else
			CMD='{"type":"ShuffleCommand","shuffle":false}'
		fi
		send_command
	;;
	
	"repeat")
		INPUT=$2
		if [ -z "$INPUT" ]; then
			echo "use ./alexa.sh repeat on  # use on/off, off is set if empty or on mismatch"
			INPUT='off'
		fi
		if [ $INPUT = "on" ] ; then
			CMD='{"type":"RepeatCommand","repeat":true}'
		else
			CMD='{"type":"RepeatCommand","repeat":false}'
		fi
		send_command
	;;
	
	"forward")
		CMD='{"type":"ForwardCommand"}'
		send_command
	;;
	"rewind")
		CMD='{"type":"RewindCommand"}'
		send_command
	;;
	
	"tunein")
		STATION=$2
		if [ -z "$STATION" ]; then
			echo "use ./alexa.sh tunein s149494  # station empty, "$tunein_default" is set"
			STATION=$tunein_default
		fi
		send_command2 
	;;
	"prime")
		MUSIK=$2
		if [ "$MUSIK" = "radio" ]; then 
			SEEDID=$3
			if [ -z "$SEEDID" ]; then
				echo "use ./alexa.sh prime radio A3C8WGK5P1KO4L  #  seedId empty, "$prime_radio_default" is set"
				SEEDID=$prime_radio_default
			fi
			send_command3
		elif [ "$MUSIK" = "playlist" ]; then
			ASIN=$3
			if [ -z "$ASIN" ]; then
				echo "use ./alexa.sh prime playlist B01N3UD4N6  #  asin empty, "$prime_playlist_default" is set"
				ASIN=$prime_playlist_default
			fi
			send_command4
		else
			echo "use ./alexa.sh prime radio AWQEQ4SVHXTEX  #  for PrimeMusic radiostations"
			echo "use ./alexa.sh prime playlist B01N3UD4N6  #  for PrimeMusic playlists"
		fi
	;;
	"cloud")
		MUSIK=$2
		if [ "$MUSIK" = "track" ]; then 
			TRACKID=$3
			if [ -z "$TRACKID" ]; then
				echo "use ./alexa.sh cloud track 63c99e9a-87fc-4e68-ac0d-a9b9b2c0ba1a  #  trackId empty, "$cloud_track_default" is set"
				TRACKID=$cloud_track_default
			fi
			CMD='{"trackId":"'$TRACKID'", "playQueuePrime":true}'
			send_command5
		elif [ "$MUSIK" = "playlist" ]; then
			PLAYLISTID=$3
			if [ -z "$PLAYLISTID" ]; then
				echo "use ./alexa.sh cloud playlist 7daba127-2c98-431f-a4bf-b1155cfcd0d1  #  playlistId empty, "$cloud_playlist_default" is set"
				PLAYLISTID=$cloud_playlist_default
			fi
			CMD='{"playlistId":"'$PLAYLISTID'","playQueuePrime":false}'
			send_command5
		else
			echo "use ./alexa.sh cloud track 63c99e9a-87fc-4e68-ac0d-a9b9b2c0ba1a  #  for cloud single tracks"
			echo "use ./alexa.sh cloud playlist 7daba127-2c98-431f-a4bf-b1155cfcd0d1  #  for cloud playlists"
		fi
	;;	
	
esac
